﻿Imports System
Imports System.Collections.Generic
Imports System.Web.Services
Imports System.Web.UI
Imports Telerik.Web.UI
Imports System.Data

Partial Class Default5
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'this is need in order to start an item fetch request
        Dim sb As New StringBuilder()
        sb.Append("function ComboBoxControl_OnClientDropDownOpening(sender,args){")
        sb.Append(" if (sender.get_items().get_count() == 0 || sender.get_items().get_count() == 1) {")
        sb.Append(" sender.requestItems("""", false);}")
        sb.Append("}")
        ScriptManager.RegisterClientScriptBlock(Me, GetType(Page), "comboScript", sb.ToString(), True)
    End Sub

    Protected Sub RadGrid1_ItemCreated(ByVal sender As Object, ByVal e As GridItemEventArgs) Handles RadGrid1.ItemCreated
        If TypeOf e.Item Is GridEditableItem AndAlso e.Item.IsInEditMode Then
            'configure CategoryComboBox for LoadOnDemand
            Dim editor As GridDropDownListColumnEditor = TryCast((DirectCast(e.Item, GridEditableItem)).EditManager.GetColumnEditor("Categories"), GridDropDownListColumnEditor)

            editor.ComboBoxControl.EnableLoadOnDemand = True
            AddHandler editor.ComboBoxControl.ItemsRequested, AddressOf ComboBoxControl_ItemsRequested
            editor.ComboBoxControl.EnableVirtualScrolling = True
            editor.ComboBoxControl.OnClientDropDownOpening = "ComboBoxControl_OnClientDropDownOpening"
        End If
    End Sub

    Private _categories As DataTable
    Public ReadOnly Property Categories() As DataTable
        Get
            If _categories Is Nothing Then
                _categories = (DirectCast(SqlDataSource2.Select(New DataSourceSelectArguments()), DataView)).Table
            End If
            Return _categories
        End Get
    End Property

    Protected Sub ComboBoxControl_ItemsRequested(ByVal source As Object, ByVal e As RadComboBoxItemsRequestedEventArgs)
        Dim radComboBox1 As RadComboBox = DirectCast(source, RadComboBox)
        Dim data As DataTable = (DirectCast(SqlDataSource2.Select(New DataSourceSelectArguments()), DataView)).Table
        Try
            Dim itemsPerRequest As Integer = 10
            Dim itemOffset As Integer = e.NumberOfItems
            Dim endOffset As Integer = itemOffset + itemsPerRequest
            If endOffset > data.Rows.Count Then
                endOffset = data.Rows.Count
            End If
            If endOffset = data.Rows.Count Then
                e.EndOfItems = True
            Else
                e.EndOfItems = False
            End If
            Dim i As Integer = itemOffset
            While i < endOffset
                radComboBox1.Items.Add(New RadComboBoxItem(data.Rows(i)("CategoryName").ToString(), data.Rows(i)("CategoryID").ToString()))
                System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
            End While

            If data.Rows.Count > 0 Then
                e.Message = [String].Format("Items <b>1</b>-<b>{0}</b> out of <b>{1}</b>", endOffset.ToString(), data.Rows.Count.ToString())
            Else
                e.Message = "No matches"
            End If
        Catch
            e.Message = "No matches"
        End Try
    End Sub

    Protected Sub RadGrid_UpdateCommand(ByVal source As Object, ByVal e As GridCommandEventArgs) Handles RadGrid1.UpdateCommand
        ' no real updates to the data base just outputted to a label!
        Dim values As New Hashtable()
        DirectCast(e.Item, GridEditableItem).ExtractValues(values)
        Label1.Text = String.Format("Updated CategoryID is {0}", values("CategoryID"))
    End Sub

    Protected Sub RadGrid1_ItemDataBound(ByVal sender As Object, ByVal e As GridItemEventArgs) Handles RadGrid1.ItemDataBound
        If TypeOf e.Item Is GridDataItem AndAlso Not e.Item.IsInEditMode Then
            'populate the category column cell

            Dim categoryId As Integer = -1
            If (DataBinder.Eval(e.Item.DataItem, "CategoryID") IsNot DBNull.Value) Then
                categoryId = DirectCast(DataBinder.Eval(e.Item.DataItem, "CategoryID"), Integer)
            End If

            Dim rows As DataRow() = Categories.Select("CategoryID = " + categoryId.ToString())
            If rows.Length > 0 Then
                DirectCast(e.Item, GridDataItem)("Categories").Text = rows(0)("CategoryName").ToString()
            End If
        End If
        If TypeOf e.Item Is GridEditableItem AndAlso e.Item.IsInEditMode Then
            'add the initally selected category to the combo
            Dim categoryId As Integer = -1
            If (DataBinder.Eval(e.Item.DataItem, "CategoryID") IsNot DBNull.Value) Then
                categoryId = DirectCast(DataBinder.Eval(e.Item.DataItem, "CategoryID"), Integer)
            End If
            Dim rows As DataRow() = Categories.Select("CategoryID = " + categoryId.ToString())
            If rows.Length > 0 Then
                Dim editor As GridDropDownListColumnEditor = TryCast((DirectCast(e.Item, GridEditableItem)).EditManager.GetColumnEditor("Categories"), GridDropDownListColumnEditor)

                editor.ComboBoxControl.Items.Add(New RadComboBoxItem(rows(0)("CategoryName").ToString(), rows(0)("CategoryID").ToString()))
            End If
        End If
    End Sub
End Class
